import { Base, IList, Type } from "./type";
import { IDataSourceLocalDataProvider } from "./IDataSourceLocalDataProvider";
import { IDataSourceSchema } from "./IDataSourceSchema";
import { DataSourceSchemaPropertyType } from "./DataSourceSchemaPropertyType";
import { IDataSourceExecutionContext } from "./IDataSourceExecutionContext";
import { IDataSourceDataProviderUpdateNotifier } from "./IDataSourceDataProviderUpdateNotifier";
import { SortDescriptionCollection } from "./SortDescriptionCollection";
import { FilterExpressionCollection } from "./FilterExpressionCollection";
import { SummaryDescriptionCollection } from "./SummaryDescriptionCollection";
import { DataSourceSummaryScope } from "./DataSourceSummaryScope";
import { DataSourceDataProviderSchemaChangedEventArgs } from "./DataSourceDataProviderSchemaChangedEventArgs";
/**
 * @hidden
 */
export declare class DataSourceLocalDataProvider extends Base implements IDataSourceLocalDataProvider {
    static $t: Type;
    constructor();
    private as;
    private m;
    private l;
    private f;
    private n;
    private e;
    private z;
    private aa;
    get dataSource(): any;
    set dataSource(a: any);
    private t;
    private ac;
    get af(): string;
    set af(a: string);
    private an;
    private c;
    schemaChanged: (sender: any, args: DataSourceDataProviderSchemaChangedEventArgs) => void;
    getItemAtIndex(a: number): any;
    private s;
    private u;
    getItemValue(a: any, b: string): any;
    setItemValue(a: any, b: string, c: any): void;
    removeItem(a: any): void;
    addItem(a: any): void;
    private aj;
    get actualCount(): number;
    private i;
    get actualSchema(): IDataSourceSchema;
    private k;
    private j;
    resolveSchemaPropertyType(a: string): DataSourceSchemaPropertyType;
    ar(a: IDataSourceSchema): void;
    private v;
    private al;
    private ak;
    private w;
    private b;
    private static d;
    private ab;
    protected am(a: string, b: any, c: any): void;
    private x;
    protected get y(): IList;
    private q;
    protected ao(a: string, b: any, c: any): void;
    private h;
    get executionContext(): IDataSourceExecutionContext;
    set executionContext(a: IDataSourceExecutionContext);
    protected get r(): boolean;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    private g;
    get updateNotifier(): IDataSourceDataProviderUpdateNotifier;
    set updateNotifier(a: IDataSourceDataProviderUpdateNotifier);
    private p;
    get deferAutoRefresh(): boolean;
    set deferAutoRefresh(a: boolean);
    get isSortingSupported(): boolean;
    get isFilteringSupported(): boolean;
    get sortDescriptions(): SortDescriptionCollection;
    get filterExpressions(): FilterExpressionCollection;
    get summaryDescriptions(): SummaryDescriptionCollection;
    get summaryScope(): DataSourceSummaryScope;
    set summaryScope(a: DataSourceSummaryScope);
    get notifyUsingSourceIndexes(): boolean;
    private a;
    get propertiesRequested(): string[];
    set propertiesRequested(a: string[]);
    get isItemIndexLookupSupported(): boolean;
    get isKeyIndexLookupSupported(): boolean;
    get isGroupingSupported(): boolean;
    get groupDescriptions(): SortDescriptionCollection;
    o: boolean;
    queueAutoRefresh(): void;
    ai(): void;
    ap(): void;
    protected aq(): void;
    flushAutoRefresh(): void;
    refresh(): void;
    indexOfItem(a: any): number;
    indexOfKey(a: any[]): number;
}
