import { Base, Type } from "./type";
import { UIElementPropertyId } from "./UIElementPropertyId";
import { NativeUIBuiltInEvents } from "./NativeUIBuiltInEvents";
import { NativeUIBuiltInProperties } from "./NativeUIBuiltInProperties";
import { NativeUIComponentHorizontalAlignment } from "./NativeUIComponentHorizontalAlignment";
import { NativeUIComponentVerticalAlignment } from "./NativeUIComponentVerticalAlignment";
import { Size } from "./Size";
import { Rect } from "./Rect";
import { NativeUIComponentBuiltInType } from "./NativeUIComponentBuiltInType";
import { BaseControlTheme } from "./BaseControlTheme";
import { Brush } from "./Brush";
import { Thickness } from "./Thickness";
import { CornerRadius } from "./CornerRadius";
import { Transform } from "./Transform";
import { NativeUICursor } from "./NativeUICursor";
import { Visibility } from "./Visibility";
import { NativeUIMouseEventArgs } from "./NativeUIMouseEventArgs";
import { NativeUIFocusEventArgs } from "./NativeUIFocusEventArgs";
import { INativeUIElementFactory } from "./INativeUIElementFactory";
import { NativeUIElementFactoryFlavor } from "./NativeUIElementFactoryFlavor";
/**
 * @hidden
 */
export interface INativeUIElementBridge {
    getMethodTarget(a: any): any;
    getTargetForProperty(a: UIElementPropertyId, b: any): any;
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
    getTargetForBuildInProperty(a: any, b: NativeUIBuiltInProperties): any;
    getTargetForBuildInEvent(a: any, b: NativeUIBuiltInEvents): any;
    getHorizontalAlignment(a: any): NativeUIComponentHorizontalAlignment;
    setHorizontalAlignment(a: any, b: NativeUIComponentHorizontalAlignment): void;
    getVerticalAlignment(a: any): NativeUIComponentVerticalAlignment;
    setVerticalAlignment(a: any, b: NativeUIComponentVerticalAlignment): void;
    getHorizontalContentAlignment(a: any): NativeUIComponentHorizontalAlignment;
    setHorizontalContentAlignment(a: any, b: NativeUIComponentHorizontalAlignment): void;
    getVerticalContentAlignment(a: any): NativeUIComponentVerticalAlignment;
    setVerticalContentAlignment(a: any, b: NativeUIComponentVerticalAlignment): void;
    getDesiredSize(a: any, b: Size): Size;
    getBoundingRect(a: any): Rect;
    contains(a: any, b: any): boolean;
    focus(a: any): void;
}
/**
 * @hidden
 */
export declare let INativeUIElementBridge_$type: Type;
/**
 * @hidden
 */
export interface INativeUIContainerBridge extends INativeUIElementBridge {
    getChildAt(a: any, b: number): NativeUIComponent;
    removeChildAt(a: any, b: number): void;
    addChild(a: any, b: NativeUIComponent): void;
    insertChild(a: any, b: number, c: NativeUIComponent): void;
    removeChild(a: any, b: NativeUIComponent): void;
    getChildrenCount(a: any): number;
}
/**
 * @hidden
 */
export declare let INativeUIContainerBridge_$type: Type;
/**
 * @hidden
 */
export declare class NativeUIComponent extends Base {
    static $t: Type;
    j: NativeUIContainer;
    ax(): void;
    bb(a: Size): Size;
    ba(): Rect;
    t(a: any): boolean;
    aw(): void;
    am: any;
    protected get_e(): NativeUIComponentBuiltInType;
    get e(): NativeUIComponentBuiltInType;
    protected get ak(): any;
    private static v;
    static ap(a: INativeUIElementFactory): void;
    private static a;
    static aq(a: any, b: NativeUIComponentBuiltInType, c: NativeUIElementFactoryFlavor, d: (arg1: any) => void): void;
    static ar(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    static as(a: any, b: NativeUIComponentBuiltInType[], c: NativeUIElementFactoryFlavor[], d: (arg1: any[]) => void): void;
    static at(a: any, b: NativeUIComponentBuiltInType[], c: (arg1: any[]) => void): void;
    static au(a: any, b: NativeUIComponentBuiltInType, c: NativeUIElementFactoryFlavor, d: (arg1: any) => void): void;
    static av(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    d: INativeUIElementBridge;
    al: any;
    protected aj(a: UIElementPropertyId): any;
    protected ag(a: UIElementPropertyId): any;
    protected a2(a: UIElementPropertyId, b: any): void;
    protected ae(a: NativeUIBuiltInProperties): any;
    protected a0(a: NativeUIBuiltInProperties, b: any): void;
    protected an(a: NativeUIBuiltInEvents, b: any): void;
    protected ao(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    protected ay(a: NativeUIBuiltInEvents, b: any): void;
    protected az(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    protected af(a: any, b: NativeUIBuiltInProperties): any;
    protected a1(a: any, b: NativeUIBuiltInProperties, c: any): void;
    protected ai(a: NativeUIBuiltInProperties): any;
    protected ah(a: NativeUIBuiltInEvents): any;
    get ad(): number;
    set ad(a: number);
    get x(): number;
    set x(a: number);
    get z(): number;
    set z(a: number);
    get c(): BaseControlTheme;
    set c(a: BaseControlTheme);
    get a4(): Brush;
    set a4(a: Brush);
    get a5(): Brush;
    set a5(a: Brush);
    get bc(): Thickness;
    set bc(a: Thickness);
    get a3(): CornerRadius;
    set a3(a: CornerRadius);
    get be(): Thickness;
    set be(a: Thickness);
    get a6(): Brush;
    set a6(a: Brush);
    get w(): number;
    set w(a: number);
    get y(): number;
    set y(a: number);
    get ac(): number;
    set ac(a: number);
    get bd(): Thickness;
    set bd(a: Thickness);
    get a9(): Transform;
    set a9(a: Transform);
    get a8(): Brush;
    set a8(a: Brush);
    get a7(): Brush;
    set a7(a: Brush);
    get ab(): number;
    set ab(a: number);
    get b(): number[];
    set b(a: number[]);
    get aa(): number;
    set aa(a: number);
    get f(): NativeUIComponentHorizontalAlignment;
    set f(a: NativeUIComponentHorizontalAlignment);
    get h(): NativeUIComponentVerticalAlignment;
    set h(a: NativeUIComponentVerticalAlignment);
    get g(): NativeUIComponentHorizontalAlignment;
    set g(a: NativeUIComponentHorizontalAlignment);
    get i(): NativeUIComponentVerticalAlignment;
    set i(a: NativeUIComponentVerticalAlignment);
    get k(): NativeUICursor;
    set k(a: NativeUICursor);
    protected get_u(): boolean;
    protected set_u(a: boolean): void;
    get u(): boolean;
    set u(a: boolean);
    get bf(): Visibility;
    set bf(a: Visibility);
    private p;
    get q(): (sender: any, args: NativeUIMouseEventArgs) => void;
    set q(a: (sender: any, args: NativeUIMouseEventArgs) => void);
    private r;
    get s(): (sender: any, args: NativeUIMouseEventArgs) => void;
    set s(a: (sender: any, args: NativeUIMouseEventArgs) => void);
    private l;
    get n(): (sender: any, args: NativeUIFocusEventArgs) => void;
    set n(a: (sender: any, args: NativeUIFocusEventArgs) => void);
    private m;
    get o(): (sender: any, args: NativeUIFocusEventArgs) => void;
    set o(a: (sender: any, args: NativeUIFocusEventArgs) => void);
}
/**
 * @hidden
 */
export declare class NativeUIContainer extends NativeUIComponent {
    static $t: Type;
    get bi(): number;
    get bg(): INativeUIContainerBridge;
    bh(a: number): NativeUIComponent;
    bm(a: number): void;
    bj(a: NativeUIComponent): void;
    bk(a: number, b: NativeUIComponent): void;
    bl(a: NativeUIComponent): void;
}
